diff --git a/drivers/media/usb/uvc/uvc_driver.c b/drivers/media/usb/uvc/uvc_driver.c
index deadbcea5e22..6d739c3cc88f 100644
--- a/drivers/media/usb/uvc/uvc_driver.c
+++ b/drivers/media/usb/uvc/uvc_driver.c
@@ -3188,6 +3188,15 @@ static const struct usb_device_id uvc_ids[] = {
 	  .bInterfaceSubClass	= 1,
 	  .bInterfaceProtocol	= 0,
 	  .driver_info		= UVC_INFO_META(V4L2_META_FMT_D4XX) },
+	/* Alcor Corp. Slave camera */
+	{ .match_flags		= USB_DEVICE_ID_MATCH_DEVICE
+				| USB_DEVICE_ID_MATCH_INT_INFO,
+	  .idVendor		= 0x1b17,
+	  .idProduct		= 0x6684,
+	  .bInterfaceClass	= USB_CLASS_VIDEO,
+	  .bInterfaceSubClass	= 1,
+	  .bInterfaceProtocol	= 0,
+	  .driver_info		= UVC_INFO_QUIRK(UVC_QUIRK_OVERFLOW_BANDWIDTH) },
 	/* Generic USB Video Class */
 	{ USB_INTERFACE_INFO(USB_CLASS_VIDEO, 1, UVC_PC_PROTOCOL_UNDEFINED) },
 	{ USB_INTERFACE_INFO(USB_CLASS_VIDEO, 1, UVC_PC_PROTOCOL_15) },
diff --git a/drivers/media/usb/uvc/uvc_video.c b/drivers/media/usb/uvc/uvc_video.c
index e3567aeb0007..7af77bf1be9b 100644
--- a/drivers/media/usb/uvc/uvc_video.c
+++ b/drivers/media/usb/uvc/uvc_video.c
@@ -226,41 +226,55 @@ static void uvc_fixup_video_ctrl(struct uvc_streaming *stream,
 	if ((ctrl->dwMaxPayloadTransferSize & 0xffff0000) == 0xffff0000)
 		ctrl->dwMaxPayloadTransferSize &= ~0xffff0000;
 
-	if (!(format->flags & UVC_FMT_FLAG_COMPRESSED) &&
-	    stream->dev->quirks & UVC_QUIRK_FIX_BANDWIDTH &&
-	    stream->intf->num_altsetting > 1) {
-		u32 interval;
-		u32 bandwidth;
-
-		interval = (ctrl->dwFrameInterval > 100000)
-			 ? ctrl->dwFrameInterval
-			 : frame->dwFrameInterval[0];
-
-		/*
-		 * Compute a bandwidth estimation by multiplying the frame
-		 * size by the number of video frames per second, divide the
-		 * result by the number of USB frames (or micro-frames for
-		 * high- and super-speed devices) per second and add the UVC
-		 * header size (assumed to be 12 bytes long).
-		 */
-		bandwidth = frame->wWidth * frame->wHeight / 8 * format->bpp;
-		bandwidth *= 10000000 / interval + 1;
-		bandwidth /= 1000;
-		if (stream->dev->udev->speed >= USB_SPEED_HIGH)
-			bandwidth /= 8;
-		bandwidth += 12;
-
-		/*
-		 * The bandwidth estimate is too low for many cameras. Don't use
-		 * maximum packet sizes lower than 1024 bytes to try and work
-		 * around the problem. According to measurements done on two
-		 * different camera models, the value is high enough to get most
-		 * resolutions working while not preventing two simultaneous
-		 * VGA streams at 15 fps.
-		 */
-		bandwidth = max_t(u32, bandwidth, 1024);
+	if (stream->intf->num_altsetting > 1) {
+		if (!(format->flags & UVC_FMT_FLAG_COMPRESSED) &&
+		    stream->dev->quirks & UVC_QUIRK_FIX_BANDWIDTH) {
+			u32 interval;
+			u32 bandwidth;
+
+			interval = (ctrl->dwFrameInterval > 100000)
+				 ? ctrl->dwFrameInterval
+				 : frame->dwFrameInterval[0];
+
+			/*
+			 * Compute a bandwidth estimation by multiplying the
+			 * frame size by the number of video frames per second,
+			 * divide the result by the number of USB frames (or
+			 * micro-frames for high- and super-speed devices) per
+			 * second and add the UVC header size (assumed to be
+			 * 12 bytes long).
+			 */
+			bandwidth = frame->wWidth * frame->wHeight / 8
+				    * format->bpp;
+			bandwidth *= 10000000 / interval + 1;
+			bandwidth /= 1000;
+			if (stream->dev->udev->speed >= USB_SPEED_HIGH)
+				bandwidth /= 8;
+			bandwidth += 12;
+
+			/*
+			 * The bandwidth estimate is too low for many cameras.
+			 * Don't use maximum packet sizes lower than 1024 bytes
+			 * to try and work around the problem. According to
+			 * measurements done on two different camera models,
+			 * the value is high enough to get most resolutions
+			 * working while not preventing two simultaneous VGA
+			 * streams at 15 fps.
+			 */
+			bandwidth = max_t(u32, bandwidth, 1024);
+
+			ctrl->dwMaxPayloadTransferSize = bandwidth;
+		}
 
-		ctrl->dwMaxPayloadTransferSize = bandwidth;
+		if (format->flags & UVC_FMT_FLAG_COMPRESSED &&
+		    stream->dev->quirks & UVC_QUIRK_OVERFLOW_BANDWIDTH &&
+		    ctrl->dwMaxPayloadTransferSize > stream->maxpsize) {
+			dev_warn(&stream->intf->dev,
+				 "the max payload transmission size (%d) exceededs the size of the ep max packet (%d). use the default value of 1024 bytes.\n",
+				 ctrl->dwMaxPayloadTransferSize,
+				 stream->maxpsize);
+			ctrl->dwMaxPayloadTransferSize = 1024;
+		}
 	}
 }
 
diff --git a/drivers/media/usb/uvc/uvcvideo.h b/drivers/media/usb/uvc/uvcvideo.h
index 5e388f05f3fc..8b43d725c259 100644
--- a/drivers/media/usb/uvc/uvcvideo.h
+++ b/drivers/media/usb/uvc/uvcvideo.h
@@ -77,6 +77,7 @@
 #define UVC_QUIRK_DISABLE_AUTOSUSPEND	0x00008000
 #define UVC_QUIRK_INVALID_DEVICE_SOF	0x00010000
 #define UVC_QUIRK_MJPEG_NO_EOF		0x00020000
+#define UVC_QUIRK_OVERFLOW_BANDWIDTH	0x00040000
 
 /* Format flags */
 #define UVC_FMT_FLAG_COMPRESSED		0x00000001